<?php

require_once('groupperm_function.php');
require_once(XOOPS_ROOT_PATH . '/modules/cinemaru/constants.php');

function cinemaru_mkdir_p()
{
    if (file_exists(XOOPS_ROOT_PATH . '/uploads/cinemaru') == false) {
	mkdir(XOOPS_ROOT_PATH . '/uploads/cinemaru');
    }
    
    if (file_exists(XOOPS_ROOT_PATH . '/uploads/cinemaru/image') == false) {
	mkdir(XOOPS_ROOT_PATH . '/uploads/cinemaru/image');
    }
    
    if (file_exists(XOOPS_ROOT_PATH . '/uploads/cinemaru/movie') == false) {
	mkdir(XOOPS_ROOT_PATH . '/uploads/cinemaru/movie');
    }
}

function cinemaru_get_randam_code()
{
    return rand(0, 9) .rand(0, 9) .rand(0, 9) .rand(0, 9) .rand(0, 9) .rand(0, 9) .rand(0, 9) .rand(0, 9);
}

function cinemaru_is_auth_perm()
{
    $groupperm_valid = cinemaru_checkright(CINEMARU_GROUPPERM_VALID);
    
    if ($groupperm_valid) {
	return true;
    }
    
    if (cinemaru_is_module_admin()) {
	return true;
    } else {
	return false;
    }
}

function cinemaru_is_auth_delele_comment()
{
    $groupperm_valid = cinemaru_checkright(CINEMARU_GROUPPERM_DELCOMMENT);
    
    if ($groupperm_valid) {
	return true;
    }
    
    if (cinemaru_is_module_admin()) {
	return true;
    } else {
	return false;
    }
}

function cinemaru_is_module_admin()
{
    global $xoopsUser;
    global $module_handler;
    
    if (! is_object($xoopsUser)) {
	return false;
    }
    
    // $mydirname is module directory name
    $module =& $module_handler->getByDirname( 'cinemaru' ) ;
    
    if( ! is_object( $module ) ) {
	die( "invalid module dirname:" . htmlspecialchars( $src_dirname ) );
    }
    $mid = $module->getvar( 'mid' ) ;
    
    return $xoopsUser->isAdmin($mid);
}

function cinemaru_mb_truncate($str, $len=16)
{
    if (function_exists('mb_substr')) {
	return mb_substr($str, 0, $len);
    } else {
	return substr($str, 0, $len);
    }
}

function cinemaru_movie_truncate($movie_list)
{
    foreach ($movie_list as $key => $val) {
	if (20 < strlen($val['title'])) {
	    $movie_list[$key]['title_trunc'] = cinemaru_mb_truncate($val['title'], CINEMARU_THUMB_TITLE_LENGTH) . '...';
	} else {
	    $movie_list[$key]['title_trunc'] = $val['title'];
	}
	if (30 < strlen($val['desc'])) {
	    $movie_list[$key]['desc_trunc'] = cinemaru_mb_truncate($val['desc'], CINEMARU_THUMB_DESC_LENGTH) . '...';
	} else {
	    $movie_list[$key]['desc_trunc'] = $val['desc'];
	}
    }
    
    return $movie_list;
}

function cinemaru_mb_convert_encoding($str, $charcode)
{
    if (function_exists('mb_convert_encoding')) {
	return mb_convert_encoding($str, $charcode, 'auto');
    } else {
	return $str;
    }
}
